#!/bin/bash

BEROCONF=/usr/fallback/beroconf

# if activity on gui or no fw installed - do not restart
[ -f /tmp/has_activity ] && exit 0
[ ! -f /usr/local/FILENAME ] && exit 0

# lighttpd-ssl failed (do not reboot the device and keep the recovery-mode state)
[ "$(${BEROCONF} get root lighttpd-ssl-failed | /bin/grep -v failed)" = "1" ] && exit 0

# check uptime: if lower than 5 min, do not reboot
if /usr/bin/uptime | /bin/grep min &>/dev/null; then
	upTime=$(/usr/bin/uptime | /usr/bin/awk '{ print $3; }')
	if [ "${upTime}" -lt "5" ]; then
		exit 0
	fi
fi

# restart the device (not an expected recovery-mode ??)
${BEROCONF} delete root boot_recoverymode

/usr/bin/env -i bash -c "/usr/php/backupManagement.php restore" >/dev/null

${BEROCONF} set root boot_skipReset 1

/sbin/reboot
exit 0
